<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\RelCancelamentoCupomService;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelCancelamentoCupom  {
    protected $dataSourceName = 'vnd55011_relCancelamentoCupom';
    protected $cancelamentoCupom;
    protected $utilService;
    
    public function __construct (RelCancelamentoCupomService $cancelamentoCupom, Utilities\Util $utilService ){
        $this->utilService = $utilService;
        $this->cancelamentoCupom = $cancelamentoCupom;
    }
    
    public function find(Request\Filter $request, Response $response) {
        try{
            $result = [];
            $conditions = $this->utilService->getParamsAsArray($request);
            if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])) {
                $response->addDataSet(new DataSet($this->dataSourceName,$this->cancelamentoCupom->getCupons($conditions)));
                return $response;
            }
            return $result;
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}