<?php

namespace Teknisa\MAN\Services;

use Teknisa\Libs\Util\Utilities;

class Certificado {
	protected $entityManager;
	protected $util;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function encrypt($text, $salt = 'teknisa') {
        return Utilities::zeedhiEncrypt($text, $salt);
    }
    
    public function getInfosByFilial($NRORG, $CDFILIAL) {
        $params = array(
            'NRORG'    => $NRORG,
			'CDFILIAL' => $CDFILIAL
		);

		$infos = $this->entityManager->getConnection()->fetchAll(self::GET_INFO_FILIAL, $params)[0];
		return $infos;
    }
    
    public function updateDsDirCert($cdinscesta, $cdempresa, $nrorg, $dsdircert, $nome, $senha, $serie, $validade) {
        $params = array(
            'P_DSDIRCERTIFICADO'  => $dsdircert,
            'P_CDINSCESTA'        => $cdinscesta,
            'P_CDEMPRESA'         => $cdempresa,
            'P_NRORG'             => $nrorg,
            'P_NMCERTIFICADO'     => $nome,
            'P_CDSENHACERTIF'     => $senha,
            'P_NRSERIECERTIFIC'   => $serie,
            'P_DTVALIDCERTIFIC'   => $validade
        );
        
        return $this->entityManager->getConnection()->executeQuery(self::UPDATE_INSCRICAO, $params);
    }
    
    public function updateDsDirCertBasico($cdinscesta, $cdempresa, $nrorg, $nome) {
        $params = array(
            'P_CDINSCESTA'        => $cdinscesta,
            'P_CDEMPRESA'         => $cdempresa,
            'P_NRORG'             => $nrorg,
            'P_NMCERTIFICADO'     => $nome
        );
        
        return $this->entityManager->getConnection()->executeQuery(self::UPDATE_INSCRICAO_BASICO, $params);
    }
	
	const GET_INFO_FILIAL = "
		SELECT
		    CDEMPRESA, CDINSCESTA
		FROM
		    FILIAL
		WHERE 
		    CDFILIAL  = :CDFILIAL
		    AND NRORG = :NRORG
	";
	
	const UPDATE_INSCRICAO = "
        UPDATE 
            INSCRESTAD
        SET 
            DSDIRCERTIFICADO   = :P_DSDIRCERTIFICADO,
            NMCERTIFICADO      = :P_NMCERTIFICADO,
            CDSENHACERTIF      = :P_CDSENHACERTIF,
            NRSERIECERTIFIC    = :P_NRSERIECERTIFIC,
            DTVALIDCERTIFIC    = :P_DTVALIDCERTIFIC,
            DTVALIDCERTIFICWEB = :P_DTVALIDCERTIFIC
        WHERE 
            CDINSCESTA    = :P_CDINSCESTA
            AND CDEMPRESA = :P_CDEMPRESA
            AND NRORG     = :P_NRORG
	";
	
	const UPDATE_INSCRICAO_BASICO = "
        UPDATE 
            INSCRESTAD
        SET 
            NMCERTIFICADO    = :P_NMCERTIFICADO
        WHERE 
            CDINSCESTA    = :P_CDINSCESTA
            AND CDEMPRESA = :P_CDEMPRESA
            AND NRORG     = :P_NRORG
	";
	
}