<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class ManutencaoBeneficioService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function checkUtilControlBeneficio($CDCLIENTE, $CDCONSUMIDOR, $CDCAMPANHA, $NRSEQBENEFICIO){
		$params = array(			
			':CDCLIENTE' 	  => $CDCLIENTE, 
			':CDCONSUMIDOR'   => $CDCONSUMIDOR,
			':CDCAMPANHA' 	  => $CDCAMPANHA,
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO
		);
        
		return $this->entityManager->getConnection()->fetchAssoc(self::CHECK_BENEFICIO_MOVBENEFICIOCTR, $params);
	}
	
		public function buscaDiasValidadben($CDCAMPANHA, $NRSEQBENEFICIO){
		$params = array(
			':CDCAMPANHA' 	  =>$CDCAMPANHA, 
			':NRSEQBENEFICIO' =>$NRSEQBENEFICIO
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_VALIDADE_BENEFICIO, $params);
	}
	
		public function insereManutencaoBeneficio($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $DTINIVALBENECONS, $DTFIMVALBENECONS, $IDTPBENEFICIO, $NRSEQBENEFICIO, $QTDEBENEFICIO, $VRBENEFICIO, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORG, $CDOPERULTATU, $NRSEQPRODCAMP){		
		$params = array(			
			':CDCAMPANHA' 		=> $CDCAMPANHA, 
			':CDCLIENTE' 		=> $CDCLIENTE, 
			':CDCONSUMIDOR' 	=> $CDCONSUMIDOR,
			':DTINIVALBENECONS' => $DTINIVALBENECONS,
			':DTFIMVALBENECONS' => $DTFIMVALBENECONS,
			':IDTPDESBENECONS' 	=> $IDTPBENEFICIO, 
			':NRSEQPRODCAMP'    => $NRSEQPRODCAMP,
			':NRSEQBENEFICIO' 	=> $NRSEQBENEFICIO, 
			':QTDEBENEFICIO' 	=> $QTDEBENEFICIO, 
			':VRDESBENECONS' 	=> $VRBENEFICIO, 
			':NRORG' 			=> $NRORG, 
			':NRORGINCLUSAO' 	=> $NRORGINCLUSAO, 
			':CDOPERINCLUSAO' 	=> $CDOPERINCLUSAO, 
			':NRORGULTATU' 		=> $NRORG, 
			':CDOPERULTATU' 	=> $CDOPERULTATU
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_BENEFICIO_MOVBENEFICIOCTR, $params);
	}
		public function updateBenefitExpiration($CDCLIENTE, $CDCONSUMIDOR, $CDCAMPANHA, $NRSEQBENEFICIO, $DTINIVALBENECONS, $DTFIMVALBENECONS,  $QTDEBENEFICIO){
		
		
		$params = array(
			':CDCLIENTE' => $CDCLIENTE,
			':CDCONSUMIDOR' => $CDCONSUMIDOR,
			':CDCAMPANHA' => $CDCAMPANHA,
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO,
			':DTINIVALBENECONS' => $DTINIVALBENECONS,
			':DTFIMVALBENECONS' => $DTFIMVALBENECONS,
			':QTDEBENEFICIO' 	=> $QTDEBENEFICIO
		);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_BENEFIT_EXPIRATION, $params);
	}
		public function buscaBeneficiosDisponiveis($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA, 
			':CDCLIENTE' => $CDCLIENTE, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR
		);

		$result = $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_BENEFICIO_DISPONIVEL, $params);
		return $result;
	}
		
		public function deleteBeneficios($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $NRSEQPRODCAMP, $NRSEQBENEFICIO, $NRORG){
			$params = array(
			':CDCAMPANHA' 	  => $CDCAMPANHA,
			':CDCLIENTE' 	  => $CDCLIENTE,
			':NRSEQPRODCAMP'  => $NRSEQPRODCAMP,
			':CDCONSUMIDOR'   => $CDCONSUMIDOR,
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO,
			';NRORG'		  => $NRORG	
			);
			return $this->entityManager->getConnection()->executeQuery(self::DELETE_BENEFICIO, $params);
		}
	
		public function updateManutencaoBeneficio($QTDEBENEFICIO, $NRORGULTATU, $CDOPERULTATU, $CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $NRSEQPRODCAMP, $NRSEQBENEFICIO){
		$params = array(
			':QTDEBENEFICIO'  => $QTDEBENEFICIO,
			':NRORGULTATU' 	  => $NRORGULTATU,
			':CDOPERULTATU'   => $CDOPERULTATU,
			':CDCAMPANHA' 	  => $CDCAMPANHA,
			':CDCLIENTE' 	  => $CDCLIENTE,
			':CDCONSUMIDOR'   => $CDCONSUMIDOR,
			':NRSEQPRODCAMP'  => $NRSEQPRODCAMP,
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO
		);		
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_BENEFICIO_MOVBENEFICIOCTR, $params);
	}

	    const CHECK_BENEFICIO_MOVBENEFICIOCTR = "
        SELECT M.CDCLIENTE, M.CDCONSUMIDOR, M.CDCAMPANHA, M.NRSEQPRODCAMP, M.NRSEQBENEFICIO, M.QTDEBENEFICIO,
               B.VRBENEFICIO, B.IDTPATIVABENEFICIO, B.IDTPBENEFICIO
          FROM MOVBENEFICIOCTR M, BENEFICIOFOS B
         WHERE M.CDCLIENTE        = :CDCLIENTE
           AND M.CDCONSUMIDOR     = :CDCONSUMIDOR
           AND M.CDCAMPANHA           = :CDCAMPANHA
           AND M.NRSEQBENEFICIO       = :NRSEQBENEFICIO
           AND M.NRSEQBENEFICIO   = B.NRSEQBENEFICIO
    ";
    
		const DELETE_BENEFICIO = "
		DELETE FROM MOVBENEFICIOCTR 
			WHERE
	    	 CDCLIENTE      = :CDCLIENTE
         AND CDCONSUMIDOR   = :CDCONSUMIDOR
         AND CDCAMPANHA     = :CDCAMPANHA
         AND NRSEQBENEFICIO = :NRSEQBENEFICIO
         AND NRSEQPRODCAMP  = :NRSEQPRODCAMP";    


}
