<?php
namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelFichaTecnicaPrecoVendaService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    public function find($conditions) {
       
        $result = $this->entityManager->getConnection()->fetchAll(self::GET_RENT_CUSTO_VENDA, $conditions);
        if(!empty($result)){
            foreach ($result as $key => $value){
                $paramCusto[':CDPRODUTO'] = $value['CDPRODUTO'];
                $paramCusto[':CDFILIAL'] = $value['CDFILIAL'];
                $paramCusto[':TIPOCUSTO'] = $conditions[':TIPOCUSTO'];
                $paramCusto[':CDLOJA'] = $value['CDLOJA'];
               $erro = false;
               try{
                    $resultCusto = $this->entityManager->getConnection()->fetchAssoc(self::CALCULA_CUSTO_COMPOSICAO, $paramCusto);
                }catch (\Exception $e){
                    $resultCusto['CUSTO'] = 0;
                    $erro = true;
                }
                if(!$erro){
                    if($resultCusto['CUSTO'] != 0){
                       $resultCusto['PERCLUCR'] = round((($value['VRUNITVEND'] - $resultCusto['CUSTO'])/$value['VRUNITVEND'])*100, 2);
                    }else{
                        $resultCusto['PERCLUCR'] = 100;
                    }
                    $resultCusto['VRRENTA'] = $value['VRUNITVEND'] - $resultCusto['CUSTO'];
                }else{
                    $resultCusto['VRRENTA'] = "Erro";
                    $resultCusto['PERCLUCR'] = "Erro";
                    $resultCusto['CUSTO'] = "Erro";
                    $result[$key]['VRUNITVEND'] = "Erro";
                }
                
                $result[$key]['VRRENTA'] = $resultCusto['VRRENTA'];
                $result[$key]['PERCLUCR'] = $resultCusto['PERCLUCR'];
                $result[$key]['VRUNITCUST'] = $resultCusto['CUSTO'];
            }
        }
        
        return $result;
    }
    const GET_RENT_CUSTO_VENDA = " 

        SELECT DISTINCT
    		   F.CDFILIAL||' - '||F.NMFILIAL AS LABELFILIAL,
    		   L.CDLOJA||' - '|| L.NMLOJA AS LABELLOJA,
    		   F.CDFILIAL , F.NMFILIAL , T.CDTABEPREC, TP.NMTABEPREC , T.DTINIVGPREC,
    		   P.CDPRODUTO, P.NMPRODUTO, NVL(I.VRPRECITEM, 0) AS VRUNITVEND,
    		   P.CDARVPROD, P.CDBARPRODUTO, L.CDLOJA, L.NMLOJA, TP.CDTABEPREC || ' - ' || TP.NMTABEPREC || ' - Vigência Inicial: ' || TO_CHAR(I.DTINIVGPREC, 'DD/MM/YY') AS NMTABEPRECGROUP
    		FROM
    		   TABEVEND T, ITEMPRECO I, ITEMVENDA IV, FILIAL F, PRODUTO P, TABEPREC TP, LOJA L
    		WHERE		   
               ((INSTR(:CDFILIAL , I.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T')) AND
               ((INSTR(:CDTABEPREC, I.CDFILIAL||I.CDTABEPREC||TO_CHAR(I.DTINIVGPREC, 'DD/MM/YY')) <> 0) OR (:TCDTABEPREC = 'T')) AND
               ((INSTR(:CDLOJA  , L.CDFILIAL||L.CDLOJA) > 0) OR (:TCDLOJA   = 'T')) AND 		   
    		   (F.CDFILIAL    = T.CDFILIAL    ) AND
    		   (F.CDFILIAL    = I.CDFILIAL    ) AND
    		   (I.CDPRODUTO   = P.CDPRODUTO   ) AND
    		   (T.CDTABEPREC  = I.CDTABEPREC  ) AND
    		   (TP.CDFILIAL   = T.CDFILIAL    ) AND
    		   (TP.CDTABEPREC = T.CDTABEPREC  ) AND 
               (T.DTINIVGPREC = I.DTINIVGPREC) AND
               (F.CDFILIAL = L.CDFILIAL) AND
               (F.NRORG = L.NRORG) AND
               (IV.CDPRODUTO = P.CDPRODUTO) AND
               (IV.NRORG = P.NRORG) AND
               (I.VRPRECITEM > 0) AND
               (I.VRPRECITEM IS NOT NULL) AND
               (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0 ) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
    		ORDER BY
    		    NMTABEPRECGROUP DESC, P.CDARVPROD, F.CDFILIAL, T.CDTABEPREC

    ";
    
    const CALCULA_CUSTO_COMPOSICAO = "
        SELECT CUSTO_COMPOSICAO(:CDPRODUTO, :CDFILIAL, :CDFILIAL, :TIPOCUSTO, 1, :CDLOJA, SYSDATE) AS CUSTO
            FROM dual
    ";
}